<?php
/// @author Leo Eibler - le [at] sprossenwanne.at
/// @date 20070326 created.
/// @date 20070327 toggle function and copyr.
///
/// @brief Dieser Code erstellt eine HTML Matrix Ansicht.
/// Auf der X-Achse werden die Dateien im Verzeichnis $source_dir angezeigt. 
/// Auf der Y-Achse die (User-)Verzeichnisse im Verzeichnis $destination_dir.
///
/// Man klickt hierbei an, welche Files zu welchen Usern kopiert werden sollen.
/// Nach dem Bettigen des Kopieren Buttons werden mittels der php Funktion copy
/// welche von Aidan Lister's copyr Funktion benutzt wird die entsprechenden
/// Dateien in die Zielverzeichnisse kopiert. 
///
/// Weiters ist es mglich, die Dateien bzw. Benutzerverzeichnisse welche
/// nicht angezeigt werden sollen in den Ausschluss Arrays 
/// $exclude_src_files und $exclude_dest_files anzugeben. Hierbei ist
/// auf Gro und Kleinschreibung zu achten.
///
/// WICHTIG !
/// Zwischen dem Aufruf des Scripts und dem Bettigen des Kopieren Buttons
/// darf sich nichts im Dateisystem ndern, da nur die Array Indizes bergeben
/// werden.
///
///

$source_dir = "./source";
$destination_dir = "./users";
$exclude_src_files = array(
                '.',
                '..',
                'test1'
                          );
$exclude_dest_files = array(
                '.',
                '..',
                'adis'     
                          );




/**
 * Copy a file, or recursively copy a folder and its contents
 *
 * author      Aidan Lister <aidan@php.net>
 * version     1.0.1
 * link        http://aidanlister.com/repos/v/function.copyr.php
 * param       string   $source    Source path
 * param       string   $dest      Destination path
 * return      bool     Returns TRUE on success, FALSE on failure
 */
function copyr($source, $dest)
{
    // Simple copy for a file
    if (is_file($source)) {
        return copy($source, $dest);
    }
 
    // Make destination directory
    if (!is_dir($dest)) {
        mkdir($dest);
    }
 
    // Loop through the folder
    $dir = dir($source);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }
 
        // Deep copy directories
        if ($dest !== "$source/$entry") {
            copyr("$source/$entry", "$dest/$entry");
        }
    }
 
    // Clean up
    $dir->close();
    return true;
}


?><html>
<head>
<title>user file copy</title>
<style type="text/css">
<!--
table, td {
  border: 1px solid black;
  border-collapse: collapse;
}

td {
  padding-left: 3px;
  padding-right: 3px;
  text-align: center;
}
-->
</style>

<script>

var rowsChecked = new Array();
var colsChecked = new Array();

function toggle_row(r) {
  if( typeof(rowsChecked[r]) != "boolean" || !rowsChecked[r] ) {
      rowsChecked[r] = false;
  }
  var inputs = document.getElementsByTagName("input");
  for( var i in inputs ) {
      if( typeof(inputs[i].name) == "string" && (inputs[i].name.substr( 0, 6 ) == "chkbox") ) {
          var elements = inputs[i].name.substr( 7 ).split("-");
          if( elements.length == 2 ) {
              if( elements[0] == r ) {
                  var el = document.getElementById(elements[0]+"-"+elements[1]);
                  if( !rowsChecked[r] ) {
                      el.checked = "checked";
                  } else {
                      el.checked = "";
                  }
              }
          }
      }
  }
  if( rowsChecked[r] ) {
      rowsChecked[r] = false;
  } else {
      rowsChecked[r] = true;
  }
}

function toggle_col(r) {
  if( typeof(colsChecked[r]) != "boolean" || !colsChecked[r] ) {
      colsChecked[r] = false;
  }
  var inputs = document.getElementsByTagName("input");
  for( var i in inputs ) {
      if( typeof(inputs[i].name) == "string" && (inputs[i].name.substr( 0, 6 ) == "chkbox") ) {
          var elements = inputs[i].name.substr( 7 ).split("-");
          if( elements.length == 2 ) {
              if( elements[1] == r ) {
                  var el = document.getElementById(elements[0]+"-"+elements[1]);
                  if( !colsChecked[r] ) {
                      el.checked = "checked";
                  } else {
                      el.checked = "";
                  }
              }
          }
      }
  }
  if( colsChecked[r] ) {
      colsChecked[r] = false;
  } else {
      colsChecked[r] = true;
  }
}
</script>
</head>
<body>
<?php
ini_set( 'display_errors', true );
ini_set( 'error_reporting', E_ALL  );

$error = '';
$files = array();
$users = array();

$file_copy_list = "";

if( !$error && !is_dir($source_dir) ) {
    $error = "Source Dir '$source_dir' ist kein Verzeichnis.";
}
if( !$error && !is_dir($destination_dir) ) {
    $error = "Destination Dir '$destination_dir' ist kein Verzeichnis.";
}
if( !$error ) {
    $src_dir = opendir($source_dir);
    $dest_dir = opendir($destination_dir);
}
if( !$error && !$src_dir ) {
    $error = "Source Dir '$source_dir' kann nicht geffnet werden.";
}

if( !$error && !$dest_dir ) {
    $error = "Destination Dir '$destination_dir' kann nicht geffnet werden.";
}

if( !$error ) {
    echo "Source Dir: '$source_dir'.\n<br />";
    echo "Destination Dir: '$destination_dir'.\n<br />";
    
    while (($file = readdir($src_dir)) !== false) {
        if( in_array( $file, $exclude_src_files ) === FALSE ) {
            $files[] = $file;
        }
    }

    while (($file = readdir($dest_dir)) !== false) {
        if( in_array( $file, $exclude_dest_files ) === FALSE ) {
            $users[] = $file;
        }
    }

    closedir($src_dir);    
    closedir($dest_dir);    

    if( isset($_POST['B1']) ) {
        foreach( $_POST as $pkey => $pval ) {
            if( substr($pkey, 0, 6) == "chkbox" ) {
                $file_user = explode( '-', substr($pkey, 7), 2);
                echo "kopiere datei '".$files[$file_user[1]]."' zu user '".$users[$file_user[0]]."'.<br />\n";
                $ret = copyr( $source_dir."/".$files[$file_user[1]], $destination_dir."/".$users[$file_user[0]]."/".$files[$file_user[1]] );
                if( !$ret ) {
                    echo "Fehler beim Kopieren von '".$source_dir."/".$files[$file_user[1]]."' nach '".$destination_dir."/".$users[$file_user[0]]."/".$files[$file_user[1]]."'.<br />\n";
                }
            }
        }
    } // if( isset($_POST['B1']) )
} // if( !$error )


if( $error ) {
    echo "<h1>Fehler</h2>".$error;
}

if( !$error ) {
?>
  <form method="post" action="userfile_copy_matrix.php">
    <table>
      <tr>
        <td>&nbsp;</td>
        <?php foreach($files as $fileid=>$file) { ?>
          <td><a title="Spalte ein/ausschalten" href="javascript:toggle_col(<?php echo $fileid; ?>);"><?php echo $file; ?></a></td>
        <?php } ?>
      </tr>
    <?php foreach($users as $usrid=>$usr) { ?>
      <tr>
        <td><a title="Reihe ein/ausschalten" href="javascript:toggle_row(<?php echo $usrid; ?>);"><?php echo $usr; ?></a></td>
        <?php foreach($files as $fileid=>$file) { ?>
          <td> <input type="checkbox" id="<?php echo $usrid.'-'.$fileid; ?>" name="chkbox_<?php echo $usrid.'-'.$fileid; ?>" value="copy" /> </td>
        <?php } ?>
      </tr>
    <?php } ?>
    </table>
    <input type="submit" name="B1" value="Kopieren" />
  </form>
<?php
} // if( !$error )
?>
</body>
</html>
